-- List all transfers made on a given Solana wallet
-- Author: Tuan
-- Date: 20240916
-- State: 
-- Todo: 
-- 0. BUG : these are not transfers but swaps !!!
-- 1. categorize withdraw / deposit depending on to_owner / from_owner
-- 2. pass the wallet address as a parameter

 
WITH
  transfers AS (
    SELECT
      block_time AS time,
      action AS action,
      amount / 1e6 AS amount,
      -- token_version as version,
    --   fee / 1e6 AS fee, 
      from_owner AS from_owner,
      to_owner AS to_owner,
      from_token_account AS from_token_account,
      to_token_account AS to_token_account,
      token_mint_address AS token_address,
      tx_id as transaction_id
    FROM
      tokens_solana.transfers
  )
SELECT
  time,
  action,
  amount,
--   fee,
  tk.symbol,
  p.symbol as symbol,
  from_owner,
  to_owner,
  from_token_account,
  to_token_account,
  COALESCE(p.price, dp.median_price) as price, -- take the price or if it does not exist, the median price.
  transaction_id,
  --version,
  token_address
FROM
  transfers
  LEFT JOIN tokens_solana.fungible tk ON tk.token_mint_address = transfers.token_address
  LEFT JOIN prices.usd p ON p.blockchain = 'solana' -- look for the price during a given minute
  and toBase58 (p.contract_address) = transfers.token_address
  and p.minute = date_trunc('minute', transfers.time)
  LEFT JOIN dune.dune.result_dex_prices_solana dp -- look for the median price during that day as a backup, in case the price does not exist
    ON dp.token_mint_address = transfers.token_address
    and date_trunc('day',transfers.time) = dp.day
    and dp.rolling_two_months_trades > 1000
    and dp.total_holders_ever > 5000
WHERE
  to_owner = 'Ckc4FEhaykq6wnKVZnbvhJCJv95xWMznPkTzGNt5F7ab'
  OR from_owner = 'Ckc4FEhaykq6wnKVZnbvhJCJv95xWMznPkTzGNt5F7ab'